/*********************************************************************
 *
 *              BLINK LED on RA0 for PIC32MX120F032B
 *
 *********************************************************************
 * Qlɂ:        custom_ld_file.c
@*                    operate_in_idle.c
 ********************************************************************/
#include <p32xxxx.h>			// Required for SFR defs
#include <plib.h>				// I/O|[gpɒǉ

// Configuration Bit settings
// SYSCLK = 80 MHz (8MHz Crystal/ FPLLIDIV * FPLLMUL / FPLLODIV)
// PBCLK = 40 MHz
// Primary Osc w/PLL (XT+,HS+,EC+PLL)
// WDT OFF
// Other options are don't care
//
#pragma config FPLLMUL = MUL_20, FPLLIDIV = DIV_2, FPLLODIV = DIV_1, FWDTEN = OFF
#pragma config POSCMOD = HS, FNOSC = PRIPLL, FPBDIV = DIV_2

#define SYS_FREQ (80000000L)
#define PB_FREQ  (40000000L)

// Let compile time pre-processor calculate the PR1 (period)
#define PB_DIV         		8
#define PRESCALE       		256
#define TOGGLES_PER_SEC		2
#define T1_TICK       		(PB_FREQ/PB_DIV/PRESCALE/TOGGLES_PER_SEC)

void foo(int index)
{
	register int i;
	for(i=0;i<index;i++);
}

int main(void)
{
	// Configure the System
    SYSTEMConfig(SYS_FREQ, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);
	// set Timer1
    OpenTimer1(T1_ON | T1_SOURCE_INT | T1_PS_1_256 | T1_IDLE_CON, T1_TICK);
    // set up the timer interrupt with a priority of 2
    ConfigIntTimer1(T1_INT_ON | T1_INT_PRIOR_2);
    // enable multi-vector interrupts
    INTEnableSystemMultiVectoredInt();

//    mPORTAClearBits(BIT_7 | BIT_6 | BIT_5 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
    mPORTAClearBits(BIT_0);

//    mPORTASetPinsDigitalOut(BIT_7 | BIT_6 | BIT_5 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
    mPORTASetPinsDigitalOut(BIT_0);

	while(1){
		foo(100000);
	}

	return 0;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Timer 1 interrupt handler

void __ISR(_TIMER_1_VECTOR, ipl2) Timer1Handler(void) {
    // clear the interrupt flag
    mT1ClearIntFlag();

    // .. things to do
    // .. in this case, toggle the LED
    mPORTAToggleBits(BIT_0);
}



